#!/bin/sh

# Not used
retcode=1;

# default dataeng_retcode
dataeng_retcode=1;

if [ "$1" == "-u" ]
then
    ./dataeng_service.sh stop > /dev/null 2>&1
    dataeng_retcode=$?
fi

# Apply ELF workarounds for megalib
applyElf() {
    [ -f libmegalib.so ] || return
    which chcon >/dev/null 2>&1 && {
        chcon -t textrel_shlib_t libmegalib.so >/dev/null 2>&1
    }
    which execstack >/dev/null 2>&1 && {
        execstack -c libmegalib.so >/dev/null 2>&1
    }
}
applyElf

# Initializing Controller Type
Ctrl_Type=""

# Check for PERC 3 family of controllers
if [[ -s "471.rom" ]]    
then
    Ctrl_Type=FP3

# Check for PERC 4/SC/DC controllers
elif [[ -s "518.rom" ]]    
then
    Ctrl_Type=FP4

# Check for PERC 4e/DC
elif [[ -s "520.rom" ]]    
then
    Ctrl_Type=FP4E

# Check for PERC 4/Di PE2600 
elif [[ -s "Disc.rom" ]]    
then
    Ctrl_Type=FD

# Check for PERC 4/Di PE1750
elif [[ -s "EV.rom" ]]    
then
    Ctrl_Type=FE

# Check for PERC 4e/Di PE2850
elif [[ -s "KB.rom" ]]    
then
    Ctrl_Type=FDRB

# Check for PERC 4e/Di PE2800
elif [[ -s "CV.rom" ]]    
then
    Ctrl_Type=FDRB

# Check for PERC 4e/Di PE6800
elif [[ -s "EX.rom" ]]    
then
    Ctrl_Type=FDRB

# Check for PERC 4e/Di PE6850
elif [[ -s "GU.rom" ]]    
then 
    Ctrl_Type=FDRB

# Check for PERC 4e/Si PE1850
elif [[ -s "BB.rom" ]]    
then
    Ctrl_Type=FDRB

# Default UNKNOWN
else
    Ctrl_Type=UNKNOWN
fi

disableCCBI() {
    # Aborting CCBI
    ./megacc.bin -abortccbi -a0 > /dev/null 2>&1
    ./megacc.bin -abortccbi -a1 > /dev/null 2>&1
    ./megacc.bin -abortccbi -a2 > /dev/null 2>&1
    ./megacc.bin -abortccbi -a3 > /dev/null 2>&1
    ./megacc.bin -abortccbi -a4 > /dev/null 2>&1
    ./megacc.bin -abortccbi -a5 > /dev/null 2>&1
    ./megacc.bin -abortccbi -a6 > /dev/null 2>&1
    ./megacc.bin -abortccbi -a7 > /dev/null 2>&1

    # Disabling CCBI
    ./megacc.bin -disablebi -a0 > /dev/null 2>&1
    ./megacc.bin -disablebi -a1 > /dev/null 2>&1
    ./megacc.bin -disablebi -a2 > /dev/null 2>&1
    ./megacc.bin -disablebi -a3 > /dev/null 2>&1
    ./megacc.bin -disablebi -a4 > /dev/null 2>&1
    ./megacc.bin -disablebi -a5 > /dev/null 2>&1
    ./megacc.bin -disablebi -a6 > /dev/null 2>&1
    ./megacc.bin -disablebi -a7 > /dev/null 2>&1
}

enableBI() {
    # Starting and Stopping CC
    ./megacc.bin -startstopCC -$Ctrl_Type > /dev/null 2>&1

    # Enabling BI 
    ./megacc.bin -enablebi -a0 > /dev/null 2>&1
    ./megacc.bin -enablebi -a1 > /dev/null 2>&1
    ./megacc.bin -enablebi -a2 > /dev/null 2>&1
    ./megacc.bin -enablebi -a3 > /dev/null 2>&1
    ./megacc.bin -enablebi -a4 > /dev/null 2>&1
    ./megacc.bin -enablebi -a5 > /dev/null 2>&1
    ./megacc.bin -enablebi -a6 > /dev/null 2>&1
    ./megacc.bin -enablebi -a7 > /dev/null 2>&1
}

[ "$Ctrl_Type" != "UNKNOWN" ] && disableCCBI
# Flashing FW
./LSIUpdate.sh $@
utility_retcode=$?
[ "$Ctrl_Type" != "UNKNOWN" ] && enableBI

if [ $dataeng_retcode -eq 0 ]
then
    ./dataeng_service.sh start > /dev/null 2>&1 
fi

exit ${utility_retcode}
