#!/bin/sh

###############################################################################
##
##          DELL COMPUTER CORPORATION PROPRIETARY INFORMATION
##
##  This software is supplied under the terms of a license agreement or
##  nondisclosure agreement with Dell Computer Corporation and may not
##  be copied or disclosed except in accordance with the terms of that
##  agreement.
##
##  Copyright (c) 1995-2001 Dell Computer Corp. All Rights Reserved.
## 
##
##  Abstract/Purpose:
##    This is the start/stop script to start/stop OMSS 
##
##  Environment:
##    Linux
##
##############################################################################

# error codes
DATAENG_ABSENT=-1
SERVICE_NOT_RUNNING=-2

# check if dataeng service exists!
if [ ! -f /etc/init.d/dataeng ]
then
	exit ${DATAENG_ABSENT};
fi
	
# Check command line parameter for action to perform
case "$1" in
	start)
		# start service
		/etc/init.d/dataeng start
		EXIT_CODE=$?
		;;

	stop)
		# stop service
		# check if service is running first
		/etc/init.d/dataeng status|grep -i running
		if [ $? != 0 ]
		then
			exit ${SERVICE_NOT_RUNNING}
		fi
		# the service is running..stop it
		/etc/init.d/dataeng stop
		EXIT_CODE=$?
esac

exit ${EXIT_CODE}


###############################################################################
# End Script
###############################################################################

