#!/bin/sh

outfile=""
syscheck="./syscheck.bin"
systemids="016F 0170"
systemnames="PE6800 PE6850"
retcode=5

errorXML() {
cat << _XML_
<?xml version="1.0" encoding="UTF-8" ?>
<SVMInventory lang="en">
    <!--
        This update package is intended for use
        on the following systems only:
            $systemnames
    -->
</SVMInventory>
_XML_
exit $retcode
}

if [ ! -z $1 ] ; then
    outfile=$1

    if [ -f $outfile ] ; then
        /bin/rm -f $outfile
    fi
fi

if [ -x $syscheck ] ; then
    $syscheck $systemids
    if [ $? -ne 0 ] ; then
        if [ -z $outfile ] ; then
            errorXML
        else
            errorXML>$outfile
        fi
    fi
fi

./LSIPIE.bin -i $outfile
